
extern void	CalcNormal(/* double x0,  double y0,  double z0,
			      double x1,  double y1,  double z1,
			      double x2,  double y2,  double z2,
			      double *nx, double *ny, double *nz */);

#define STL_TYPE_ASCII	0
#define STL_TYPE_BINARY	1

typedef struct {
		FILE	*file;
		int	type;
		union {
			struct {
				int	chr,pos;
				char	str[80];
			} a;
			struct {
				int	cnt,num;
				size_t	(*fread)();
			} b;
		} u;
	} STL;

extern int	SetUpSTL(/* STL *stl, FILE *file */),
		ScanSTL(/* STL *stl, float *x0, float *y0, float *z0,
				     float *x1, float *y1, float *z1,
				     float *x2, float *y2, float *z2
#ifdef	STL_COLOR
				   , short *flag
#endif
			*/);

typedef struct Facet {
			float		x0,y0,z0,x1,y1,z1,x2,y2,z2;
#ifdef	STL_COLOR
			short		flag;
#endif
			struct Facet	*next;
	} Facet;

extern Facet	*AllocFacet(/* float x0,  float y0,  float z0,
			       float x1,  float y1,  float z1,
			       float x2,  float y2,  float z2
#ifdef	STL_COLOR
			     , short flag
#endif
			    */),
		*ReadFacet(/* FILE *file */);

#ifdef	STL_COLOR
#define STL_COLOR_FLAG(flag)	((flag)&32768)
#define STL_COLOR_R(flag)	((double)(((flag)>>10)&31)/31.0)
#define STL_COLOR_G(flag)	((double)(((flag)>> 5)&31)/31.0)
#define STL_COLOR_B(flag)	((double)( (flag)     &31)/31.0)
#endif
