
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "stl.h"

#define SHORT	unsigned short

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	int	f,idx,lim=0,*bin=NULL;
	double	R,G,B,size,nx,ny,nz;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
	SHORT	flag;

	if (argc!=3 && argc!=4 && argc!=6) {
	    fputs("usage : stl_ac STL_file {flag|(R G B)} bin_size\n",stderr);
	    exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		fprintf(stderr,"%s : STL file not found.\n",argv[1]); exit(1);
	    }

	if (!SetUpSTL(&stl,file)) {
	    fprintf(stderr,"%s : STL header read error.\n",argv[1]); exit(1);
	}
	switch(argc) {
	    case 4:
		if ((f=atoi(argv[2]))<0 || f>=(1<<(8*sizeof(SHORT)))) {
		    fputs("bad flag.\n",stderr); exit(1);
		}
		break;
	    case 6:
		if ((R=atof(argv[2]))<0.0 || R>255.0 ||
		    (G=atof(argv[3]))<0.0 || G>255.0 ||
		    (B=atof(argv[4]))<0.0 || B>255.0) {
		    fputs("bad color.\n",stderr); exit(1);
		}
		f=32768|((int)(R*31.0/255.0+0.5)<<10)|
			((int)(G*31.0/255.0+0.5)<< 5)|
			 (int)(B*31.0/255.0+0.5)     ;
		break;
	}
	if ((size=atof(argv[argc-1]))<=0.0) {
	    fputs("bad bin size.\n",stderr); exit(1);
	}
	while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,&flag)>0)
	    if (argc==3 || f==(int)flag) {
		x1-=x0; y1-=y0; z1-=z0;
		x2-=x0; y2-=y0; z2-=z0;
		nx=y1*z2-z1*y2; ny=z1*x2-x1*z2; nz=x1*y2-y1*x2;
		idx=(int)floor(sqrt(nx*nx+ny*ny+nz*nz)/(2.0*size)+0.5);
		if (idx>=lim) {
		    if ((bin=(int *)realloc(bin,(idx+1)*sizeof(*bin)))==NULL) {
			fputs("bin memory allocation error.\n",stderr); exit(1);
		    }
		    do bin[lim]=0; while (++lim<=idx);
		}
		++bin[idx];
	    }

	for (idx=0; idx<lim; idx++)
	    if (bin[idx]) printf("%d\t%lf\t%lf\t\t%d\n",
				 idx,(idx)?((double)idx-0.5)*size:0.0,
				     ((double)idx+0.5)*size,bin[idx]);

	return 0;
}
