
#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

#define PRINT(title,x,y,z)	fputs(title,stdout);\
				putchar(' '); printf(format,x);\
				putchar(' '); printf(format,y);\
				putchar(' '); printf(format,z); putchar('\n')

int	main(argc,argv)
int	argc;
char	**argv;
{
	char		*format="%lf";
	FILE		*file;
	STL		stl;
	float		x0,y0,z0,x1,y1,z1,x2,y2,z2;
	double		nx,ny,nz;

	if (argc!=2 && argc!=3) {
	    fputs("usage : stl_b2a binary_STL {format}\n",stderr); exit(1);
	}
	if (argc==3) format=argv[2];

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		fprintf(stderr,"%s : file not found.\n",argv[1]); exit(1);
	    }

	if (!SetUpSTL(&stl,file)) {
	    fprintf(stderr,"%s : STL header read error.\n",argv[1]); exit(1);
	}
	if (stl.type==STL_TYPE_ASCII)
	    fprintf(stderr,"%s : just an ASCII STL (warning).\n",argv[1]);

	puts("solid");

	while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2)>0) {
	    CalcNormal((double)x0,(double)y0,(double)z0,
		       (double)x1,(double)y1,(double)z1,
		       (double)x2,(double)y2,(double)z2,&nx,&ny,&nz);

	    PRINT("facet normal",nx,ny,nz);
	    puts("outer loop");
	    PRINT("vertex",(double)x0,(double)y0,(double)z0);
	    PRINT("vertex",(double)x1,(double)y1,(double)z1);
	    PRINT("vertex",(double)x2,(double)y2,(double)z2);
	    puts("endloop");
	    puts("endfacet");
	}
	puts("endsolid");

	if (file!=stdin) fclose(file);

	return 0;
}
