
#include <stdio.h>
#include "stl.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
#ifdef	STL_COLOR
	short	flag;
#endif

	if (argc==1) {
	    fputs("usage : stl_dmp STL_files\n",stderr); exit(1);
	}
	while (--argc>0) {
	    if (**(++argv)=='-')
		file=stdin;
	    else
		if ((file=fopen(*argv,"rb"))==NULL) {
		    fprintf(stderr,"%s : file not found.\n",*argv); continue;
		}

	    if (!SetUpSTL(&stl,file))
		fprintf(stderr,"%s : STL header read error.\n",*argv);
	    else {
		puts(*argv);

#ifdef	STL_COLOR
		while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,
			       &flag)>0)
		    if (STL_COLOR_FLAG(flag))
			printf("%f %f %f %f %f %f %f %f %f %d %d %d\n",
			       x0,y0,z0,x1,y1,z1,x2,y2,z2,
			       (int)(STL_COLOR_R(flag)*255.0+0.5),
			       (int)(STL_COLOR_G(flag)*255.0+0.5),
			       (int)(STL_COLOR_B(flag)*255.0+0.5));
		    else
			printf("%f %f %f %f %f %f %f %f %f\n",
			       x0,y0,z0,x1,y1,z1,x2,y2,z2);
#else
		while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2)>0)
		    printf("%f %f %f %f %f %f %f %f %f\n",
			   x0,y0,z0,x1,y1,z1,x2,y2,z2);
#endif
	    }
	    if (file!=stdin) fclose(file);
	}
	return 0;
}
