
#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

static void	Abort(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s.\n",path,msg); exit(1);
}

static size_t	fWriteReverse(ptr,size,items,file)
unsigned char	*ptr;
size_t		size,items;
FILE		*file;
{
	unsigned char	*p,*h,*t,c;
	size_t		i,s=size-1;

	for (p=ptr, i=0; i<items; i++, p+=size)
	    for (h=p, t=p+s; h<t; h++, t--) {
		c=(*h); *h=(*t); *t=c;
	    }

	return fwrite(ptr,size,items,file);
}

#define ORG	argv[1]
#define NEW	argv[argc-1]

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE		*org,*new;
	STL		stl;
	double		rx,ry,rz,nx,ny,nz;
	int		idx,num;
	float		xyz[12];
#ifdef	STL_COLOR
	short		flag;
#else
	short		flag=0;
#endif
	unsigned short	us=0x1234;
	unsigned char	*uc=(unsigned char *)&us;
	size_t		(*fWrite)()=(*uc==(us&0xff))?fwrite:fWriteReverse;

	if (argc!=4 && argc!=6) {
	    fputs("usage : stl_resize orgSTL ratio|(Rx Ry Rz) newSTL\n",stderr);
	    exit(1);
	}

	if (ORG[0]=='-')
	    org=stdin;
	else
	    if ((org=fopen(ORG,"rb"))==NULL) Abort(ORG,"file not found");

	if (!SetUpSTL(&stl,org)) Abort(ORG,"STL header read error");

	if (argc==4)
	    rx=ry=rz=atof(argv[2]);
	else {
	    rx=atof(argv[2]); ry=atof(argv[3]); rz=atof(argv[4]);
	}

	if ((new=fopen(NEW,"wb"))==NULL) Abort(NEW,"file not stored");

	for (idx=80+sizeof(num); idx>0; idx--) fputc(0,new);

#ifdef	STL_COLOR
	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11,&flag)>0; num++) {
#else
	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11)>0; num++) {
#endif
	    CalcNormal((double)(xyz[ 3]*=rx),
		       (double)(xyz[ 4]*=ry),
		       (double)(xyz[ 5]*=rz),
		       (double)(xyz[ 6]*=rx),
		       (double)(xyz[ 7]*=ry),
		       (double)(xyz[ 8]*=rz),
		       (double)(xyz[ 9]*=rx),
		       (double)(xyz[10]*=ry),
		       (double)(xyz[11]*=rz),&nx,&ny,&nz); xyz[0]=nx;
							   xyz[1]=ny;
							   xyz[2]=nz;
	    if ((*fWrite)(xyz,sizeof(*xyz),12,new)!=12 ||
		(*fWrite)(&flag,sizeof(flag),1,new)!=1)
		Abort(NEW,"STL facet data write error");
	}
	if (org!=stdin) fclose(org);

	if ((new=freopen(NEW,"rb+",new))==NULL ||
	    fseek(new,80L,SEEK_SET) ||
	    (*fWrite)(&num,sizeof(num),1,new)!=1)
	    Abort(NEW,"STL facet number write error");

	fclose(new);

	return 0;
}
