
#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

static void	Abort(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s.\n",path,msg); exit(1);
}

static size_t	fWriteReverse(ptr,size,items,file)
unsigned char	*ptr;
size_t		size,items;
FILE		*file;
{
	unsigned char	*p,*h,*t,c;
	size_t		i,s=size-1;

	for (p=ptr, i=0; i<items; i++, p+=size)
	    for (h=p, t=p+s; h<t; h++, t--) {
		c=(*h); *h=(*t); *t=c;
	    }

	return fwrite(ptr,size,items,file);
}

#define ORG	argv[1]
#define NEW	argv[5]

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE		*org,*new;
	STL		stl;
	double		sx,sy,sz,nx,ny,nz;
	int		idx,num;
	float		xyz[12];
#ifdef	STL_COLOR
	short		flag;
#else
	short		flag=0;
#endif
	unsigned short	us=0x1234;
	unsigned char	*uc=(unsigned char *)&us;
	size_t		(*fWrite)()=(*uc==(us&0xff))?fwrite:fWriteReverse;

	if (argc!=6) {
	    fputs("usage : stl_shift orgSTL Sx Sy Sz newSTL\n",stderr); exit(1);
	}

	if (ORG[0]=='-')
	    org=stdin;
	else
	    if ((org=fopen(ORG,"rb"))==NULL) Abort(ORG,"file not found");

	if (!SetUpSTL(&stl,org)) Abort(ORG,"STL header read error");

	sx=atof(argv[2]); sy=atof(argv[3]); sz=atof(argv[4]);

	if ((new=fopen(NEW,"wb"))==NULL) Abort(NEW,"file not stored");

	for (idx=80+sizeof(num); idx>0; idx--) fputc(0,new);

#ifdef	STL_COLOR
	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11,&flag)>0; num++) {
#else
	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11)>0; num++) {
#endif
	    CalcNormal((double)xyz[3],(double)xyz[ 4],(double)xyz[ 5],
		       (double)xyz[6],(double)xyz[ 7],(double)xyz[ 8],
		       (double)xyz[9],(double)xyz[10],(double)xyz[11],
		       &nx,&ny,&nz);

	    xyz[0]=nx; xyz[3]+=sx; xyz[6]+=sx; xyz[ 9]+=sx;
	    xyz[1]=ny; xyz[4]+=sy; xyz[7]+=sy; xyz[10]+=sy;
	    xyz[2]=nz; xyz[5]+=sz; xyz[8]+=sz; xyz[11]+=sz;

	    if ((*fWrite)(xyz,sizeof(*xyz),12,new)!=12 ||
		(*fWrite)(&flag,sizeof(flag),1,new)!=1)
		Abort(NEW,"STL facet data write error");
	}
	if (org!=stdin) fclose(org);

	if ((new=freopen(NEW,"rb+",new))==NULL ||
	    fseek(new,80L,SEEK_SET) ||
	    (*fWrite)(&num,sizeof(num),1,new)!=1)
	    Abort(NEW,"STL facet number write error");

	fclose(new);

	return 0;
}
