
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

static void	Normal4(ptr,file)
char		*ptr;
FILE		*file;
{
	(void)fwrite(ptr,(size_t)4,(size_t)1,file);
}

static void	Reverse4(ptr,file)
char		*ptr;
FILE		*file;
{
	(void)fwrite(ptr+3,(size_t)1,(size_t)1,file);
	(void)fwrite(ptr+2,(size_t)1,(size_t)1,file);
	(void)fwrite(ptr+1,(size_t)1,(size_t)1,file);
	(void)fwrite(ptr+0,(size_t)1,(size_t)1,file);
}

#define WORD	unsigned int
#define BYTE	unsigned char

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	WORD	V,F,v,f,v0,v1,v2,r,g,b,R=255,G=255,B=255,word=255;
	char	text[LEN],RGB[3][LEN],*bf="bad face.";
	FILE	*file;
	float	x,y,z;
	BYTE	*byte=(BYTE *)&word;
	void	(*Fwrite4)()=(*byte==(BYTE)(word&255))?Normal4:Reverse4;

	if (argc!=2 && argc!=5) Error("usage : vf2zcp ZCP {R G B}");

	if (argc==5 && (sscanf(argv[2],"%u",&R)!=1 || R>255 ||
			sscanf(argv[3],"%u",&G)!=1 || G>255 ||
			sscanf(argv[4],"%u",&B)!=1 || B>255))
	    Error("bad face's default R, G and/or B values.");

	if (fgets(text,LEN,stdin)==NULL ||
	    sscanf(text,"%u %u",&V,&F)!=2 || V==0 || F==0)
	    Error("bad number of vertices and/or faces.");

	if (argv[1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[1],"wb"))==NULL) Error("file not stored.");

	(void)fprintf(file,"ply\n"
			   "format binary_little_endian 1.0\n"
			   "element vertex %u\n"
			   "property float x\n"
			   "property float y\n"
			   "property float z\n"
			   "element face %u\n"
			   "property uchar red\n"
			   "property uchar green\n"
			   "property uchar blue\n"
			   "property list uchar int vertex_indices\n"
			   "end_header\n",V,F);

	for (v=0; v<V; v++) {
	    if (fgets(text,LEN,stdin)==NULL ||
		sscanf(text,"%f %f %f",&x,&y,&z)!=3) Error("bad vertex.");

	    (*Fwrite4)((char *)&x,file);
	    (*Fwrite4)((char *)&y,file);
	    (*Fwrite4)((char *)&z,file);
	}
	for (f=0; f<F; f++) {
	    if (fgets(text,LEN,stdin)==NULL) Error(bf);

	    switch(sscanf(text,"%u %u %u %s %s %s",
			       &v0,&v1,&v2,RGB[0],RGB[1],RGB[2])) {
		case 3:
		    r=R; g=G; b=B; break;
		case 4:
		    if (sscanf(RGB[0],"%u",&r)!=1) Error(bf);

		    g=b=r; break;
		case 6:
		    if (sscanf(RGB[0],"%u",&r)!=1 ||
			sscanf(RGB[1],"%u",&g)!=1 ||
			sscanf(RGB[2],"%u",&b)!=1) Error(bf);

		    break;
		default:
		    Error(bf);
	    }
	    if (v0>=V || v1>=V || v2>=V || r>255 || g>255 || b>255) Error(bf);

	    (void)fputc(r,file);
	    (void)fputc(g,file);
	    (void)fputc(b,file);
	    (void)fputc(3,file);
	    (*Fwrite4)((char *)&v0,file);
	    (*Fwrite4)((char *)&v1,file);
	    (*Fwrite4)((char *)&v2,file);
	}
	if (file!=stdout) (void)fclose(file); return 0;
}
